/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Autorizacion;
import com.rjconsultores.ventaboletos.service.AutorizacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarAutorizacionController")
@Scope("prototype")
public class EditarAutorizacionController extends MyGenericForwardComposer {

    @Autowired
    private AutorizacionService autorizacionService;
    private Autorizacion autorizacion;
    private MyListbox autorizacionList;
    private static Logger log = Logger.getLogger(EditarAutorizacionController.class);
    private Textbox txtNombAutorizacion;
    private Textbox txtDescAutorizacion;
    private Button btnApagar;

    public Autorizacion getAutorizacion() {
        return autorizacion;
    }

    public void setAutorizacion(Autorizacion autorizacion) {
        this.autorizacion = autorizacion;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Textbox getTxtDescAutorizacion() {
        return txtDescAutorizacion;
    }

    public void setTxtDescAutorizacion(Textbox txtDescAutorizacion) {
        this.txtDescAutorizacion = txtDescAutorizacion;
    }

    public Textbox getTxtNombAutorizacion() {
        return txtNombAutorizacion;
    }

    public void setTxtNombAutorizacion(Textbox txtNombAutorizacion) {
        this.txtNombAutorizacion = txtNombAutorizacion;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        autorizacion = (Autorizacion) Executions.getCurrent().getArg().get("autorizacion");
        autorizacionList = (MyListbox) Executions.getCurrent().getArg().get("autorizacionList");

        txtNombAutorizacion.focus();

        if (autorizacion.getAutorizacionId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNombAutorizacion.getValue();

        try {
            autorizacion.setActivo(Boolean.TRUE);
            autorizacion.setFecmodif(Calendar.getInstance().getTime());
            autorizacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<Autorizacion> lsAutorizacion =
                    autorizacionService.buscar(autorizacion.getNombautorizacion(),
                    autorizacion.getDescautorizacion());

            if (!lsAutorizacion.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarAutorizacionController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (autorizacion.getAutorizacionId() == null) {
                    autorizacionService.suscribir(autorizacion);
                    autorizacionList.addItem(autorizacion);
                } else {
                    autorizacionService.actualizacion(autorizacion);
                    autorizacionList.updateItem(autorizacion);
                }

                Messagebox.show(
                        Labels.getLabel("editarAutorizacionController.MSG.suscribirOK"),
                        Labels.getLabel("editarAutorizacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarAutorizacionController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarAutorizacionController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarAutorizacionController.MSG.borrarPergunta"),
                    Labels.getLabel("editarAutorizacionController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                autorizacionService.borrar(autorizacion);

                Messagebox.show(
                        Labels.getLabel("editarAutorizacionController.MSG.borrarOK"),
                        Labels.getLabel("editarAutorizacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                autorizacionList.removeItem(autorizacion);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
